<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<link href="https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900|Material+Icons" rel="stylesheet" type="text/css">
<link href="https://cdn.jsdelivr.net/npm/quasar@2.16.4/dist/quasar.prod.css" rel="stylesheet" type="text/css">
<style>
    mark {
      padding: 0;
      margin: 0;
      border: 0;
      background-color: transparent;
    }
    mark.refs1enable {
      background-color: rgba(0,188,212,0.4);
    }
    mark.refs2enable {
      background-color: rgba(0,188,212,0.2);
    }
    mark.refsenable {
      background-color: rgba(0,188,212,0.6);
    }

    mark.hover2 {
      background-color: rgba(255, 0, 0, 0.2);
    }
    pre.hover2 mark {
      background-color: rgba(255, 0, 0, 0.2);
    }

    mark.hover1 {
      background-color: rgba(255, 0, 0, 0.4);
    }
    pre.hover1 mark {
      background-color: rgba(255, 0, 0, 0.4);
    }

    mark.hover {
      background-color: rgba(255, 0, 0, 0.6);
    }
    pre.hover mark {
      background-color: rgba(255, 0, 0, 0.6);
    }

    mark.refs1selected {
      background-color: rgba(125, 255, 0, 0.4);
    }
    mark.refs2selected {
      background-color: rgba(125, 255, 0, 0.2);
    }
    mark.refsselected {
      background-color: rgba(125, 255, 0, 0.6);
    }
    div.selected {
      background-color: rgba(125, 255, 0, 0.4);
    }

    pre {
      padding: 0;
      margin: 0;
      border: 0;
      white-space: pre-wrap;       /* CSS 2.1 */
      white-space: -moz-pre-wrap;  /* Mozilla, since 1999 */
      white-space: -pre-wrap;      /* Opera 4-6 */
      white-space: -o-pre-wrap;    /* Opera 7 */
      word-wrap: break-word;       /* Internet Explorer 5.5+ */
      color:inherit !important;
    }
</style>
</head>

<body>
<!-- injection point for quasar app -->
<div id="q-app" style="min-height: 100vh;">

<!-- form -->
<div class="q-pa-md">
  <div class="q-gutter-md row items-start">

    <!-- input fields -->
    <q-select filled Hint="Rekenmodel" label :options="functionality_options" v-model="functionality" options-html display-value-html>
      <template v-slot:label>
        <span style='min-width: 238px; display: inline-block;'>model</span>functionaliteit
      </template>
    </q-select>
    <q-separator spaced></q-separator>

    <q-input v-if="neededInputs.includes('Geboortedatum')" filled label="Datum" hint="Geboortedatum" v-model="geboortedatum" style="width:140px;">
      <template v-slot:append>
        <q-icon name="event" class="cursor-pointer">
          <q-popup-proxy cover transition-show="scale" transition-hide="scale">
            <q-date v-model="geboortedatum" mask="YYYY-MM-DD">
              <div class="row items-center justify-end">
                <q-btn v-close-popup label="Close" color="primary" flat />
              </div>
            </q-date>
          </q-popup-proxy>
        </q-icon>
      </template>
    </q-input>

    <q-input v-if="neededInputs.includes('Vandaag')" filled label="Datum" hint="Vandaag" v-model="vandaag" style="width:140px;">
      <template v-slot:append>
        <q-icon name="event" class="cursor-pointer">
          <q-popup-proxy cover transition-show="scale" transition-hide="scale">
            <q-date v-model="vandaag" mask="YYYY-MM-DD">
              <div class="row items-center justify-end">
                <q-btn v-close-popup label="Close" color="primary" flat />
              </div>
            </q-date>
          </q-popup-proxy>
        </q-icon>
      </template>
    </q-input>

    <q-select v-if="neededInputs.includes('Kalenderjaar')" filled label="Jaar" hint="Kalenderjaar" :options="[2022, 2023, 2024]" v-model="kalenderjaar"></q-select>

    <q-input v-if="neededInputs.includes('AowBedrag')" filled id="AowBedrag" name="AowBedrag" hint="AOW bedrag" v-model="aowBedrag" style="width:100px;"></q-input>

    <q-input v-if="neededInputs.includes('PotjesBedragen')" filled id="PotjesBedragen" name="PotjesBedragen" hint="Pensioen potjes" v-model="potjesBedragen"></q-input>

    <q-separator spaced></q-separator>
    <q-btn color="primary" label="Bereken" :loading="btn_disabled" @click="formSubmit"></q-btn>
    <q-toggle color="primary" label="Gedetailleerd" v-model="detailedTree"></q-btn>
  </div>
</div>

<!-- tree -->
<div class="q-pa-md">
  <div class="q-pa-md row q-col-gutter-sm full-height">
    <q-splitter v-model="treeSplitterModel" >
      <template v-slot:before>
        <div class="full-height" style="max-width: 100%; flex-grow: 1;">
        <q-scroll-area class="full-height" style="max-width: 100%; flex-grow: 1;">
        <q-tree ref="treeRef" :dense="detailedTree" class="col-12 col-sm-6"
          :nodes="nodes"
          node-key="key"
          tick-strategy="strict"
          v-model:selected="selected"
          v-model:ticked="ticked"
          v-model:expanded="expanded"
          control-color="cyan"
          selected-color="black"
        >
          <template v-slot:default-header="prop">
            <div style="min-height:100%;" :class="(selected==prop.node.key)?'selected':''"
              @mouseenter="()=>{
                prop.node.preLabelClass = prop.node.children ? 'hover1' : 'hover';
                prop.node.preBodyClass = 'hover2';
                enableMarks(prop.node.refs1, 'hover1');
                enableMarks(prop.node.refs2, 'hover2');
                enableMarks(prop.node.refs, 'hover');
                if (prop.node.children) {
                  prop.node.children.forEach(child => {
                    child.preLabelClass = child.children ? 'hover1' : 'hover';
                    child.preBodyClass = 'hover2';
                    enableMarks(child.refs1, 'hover1');
                    enableMarks(child.refs2, 'hover2');
                    enableMarks(child.refs, 'hover');
                  })
                }
              }"
              @mouseleave="()=>{
                prop.node.preLabelClass = '';
                prop.node.preBodyClass = '';
                disableMarks(prop.node.refs1, 'hover1');
                disableMarks(prop.node.refs2, 'hover2');
                disableMarks(prop.node.refs, 'hover');
                if (prop.node.children) {
                  prop.node.children.forEach(child => {
                    child.preLabelClass = '';
                    child.preBodyClass = '';
                    disableMarks(child.refs1, 'hover1');
                    disableMarks(child.refs2, 'hover2');
                    disableMarks(child.refs, 'hover');
                  })
                }
              }"
            >
              <div v-html="prop.node.label"></div>
              <pre v-html="prop.node.preLabel" :class="prop.node.preLabelClass"></pre>
            </div>
          </template>
          <template v-slot:default-body="prop" v-if="detailedTree">
            {{ prop.node.body }}
            <pre v-html="prop.node.preBody" :class="prop.node.preBodyClass"></pre>
          </template>
        </q-tree>
        </q-scroll-area>
        </div>
      </template>
      <template v-slot:after>
        <div class="full-height" style="min-height:1500px">
        <q-splitter v-model="tabSplitterModel" >
          <template v-slot:before>
            <q-tab-panels
              v-model="tabSelected"
              animated
              vertical
              transition-prev="jump-up"
              transition-next="jump-up"
            >
              <q-tab-panel v-for="tab in tabs" :key="tab.name" :name="tab.name">
                <div class="q-mb-md full-height" v-html="tab.marked"></div>
              </q-tab-panel>
            </q-tab-panels>
          </template>
          <template v-slot:after>
            <q-tabs v-model="tabSelected"
              vertical
              align="left"
              active-bg-color="blue-grey-1"
              switch-indicator
            >
              <q-tab 
               no-caps
               v-for="tab in tabs" :key="tab.name" 
                                   :name="tab.name" 
               ><div style="text-align:left; width:100%;">{{tab.label}}</div></q-tab>
            </q-tabs>
          </template>
        </q-splitter>
        </div>
      </template>
    </q-splitter>
  </div>
</div>

</div>

<button type="button" onclick="getElementById('solution').collapseAll()">collapseAll</button>
<button type="button" onclick="getElementById('solution').expandAll()">expandAll</button>

<!-- json-viewer docs: https://github.com/alenaksu/json-viewer -->
<json-viewer id="solution"></json-viewer>
<script src="https://unpkg.com/@alenaksu/json-viewer@2.0.1/dist/json-viewer.bundle.js"></script>

<!-- quasar and vue for: https://quasar.dev/start/umd/ -->
<script src="https://cdn.jsdelivr.net/npm/vue@3/dist/vue.global.prod.js"></script>
<script src="https://cdn.jsdelivr.net/npm/quasar@2.16.4/dist/quasar.umd.prod.js"></script>

<script type=module>
import { traceableAsync, start } from "/lib/v1/model-executor.js"
import utils from "/v1/utils.js"
const { ref, onMounted, watch } = Vue

const app = Vue.createApp({
  setup () {
    const functionality = ref(null)
    const functionality_options = ref([])
    const geboortedatum = ref('1957-07-31')
    const vandaag = ref('2024-07-04')

    const kalenderjaar = ref('2024')
    const aowBedrag = ref('40000')
    const potjesBedragen = ref('30000 20000')
    const btn_disabled = ref(true)

    const treeSplitterModel = ref(30)
    const tabSplitterModel = ref(80)
    const tabs = ref([])
    const tabSelected = ref(null)

    const treeRef = ref(null)
    const selected = ref(null)
    const ticked = ref([])
    const expanded = ref([])
    const nodes = ref([])
    const detailedTree = ref(false)

    let model2spec
    let fileObjects
    let className2file

    const neededInputs = ref([])

    onMounted(async () => {
      console.log(`the component is now mounted.`)
      await start("/models/v1/")
      btn_disabled.value = false
      console.log(`button is enabled`)
      const config = await fetch('/v1/config.json').then(response => response.json())

      model2spec = await utils.loadSpecs(config.modelFunctionalityOptions)
      ; [fileObjects, className2file] = await utils.loadTexts(config.texts)
      utils.pri({config});
      utils.pri({fileObjects})
      utils.pri({className2file})
      const menu_options = []
      for (const opt of config.modelFunctionalityOptions) {
        menu_options.push({
          label: `<span style="min-width: 175px; display: inline-block;">${opt.model}:</span> <strong>${opt.functionality}</strong>`,
          value: opt
        })
      }
      functionality_options.value = menu_options
      functionality.value = menu_options[menu_options.length - 1]
    })

    function enableMarks(refs, cls) {
        //console.log("enableMarks", refs)
        if (refs && refs.length > 0) {
            const marks = document.querySelectorAll(refs.map(id => `mark.${id}`).join(', '));
            marks.forEach(mark => { mark.classList.add(cls) })
        }
    }
    function disableMarks(refs, cls) {
        //console.log("disableMarks", refs)
        if (refs && refs.length > 0) {
            const marks = document.querySelectorAll(refs.map(id => `mark.${id}`).join(', '));
            marks.forEach(mark => { mark.classList.remove(cls) })
        }
    }

    function printNode(obj) {
      console.log(nodeStr(obj))
    }
    function nodeStr(obj) {
        return JSON.stringify(obj, (key, value) => {
            if (key === "children") {
              return undefined;
            }
            return value;
        }, 2)
    }
    function setTicket(detailed){
        if (detailed) {
           ticked.value = nodes.value.map(allChildKeys).flat(1)
        } else {
            ticked.value = nodes.value.map(y=>allChildKeysFiltered(y, x=>x.hasOwnProperty('children'))).flat(1)
        }
    }
    watch(detailedTree, setTicket)
    watch(tabSelected, (newValue, oldValue) => {
        highlightSelected(selected.value, selected.value)
        highlightTicked(ticked.value, ticked.value)
    })

    watch(functionality, (newValue, oldValue) => {
        if (newValue) {
            neededInputs.value = model2spec[newValue.value.model].functionalities[newValue.value.functionality].inputs
        } else {
            neededInputs.value = []
        }
    })
    function highlightSelected(newValue, oldValue) {
        if (oldValue){
            const oldNode = treeRef.value.getNodeByKey(oldValue)
            if (oldNode.hasOwnProperty('refs1') && oldNode.refs1) disableMarks(oldNode.refs1, 'refs1selected')
            if (oldNode.hasOwnProperty('refs2') && oldNode.refs2) disableMarks(oldNode.refs2, 'refs2selected')
            if (oldNode.hasOwnProperty('refs') && oldNode.refs)   disableMarks(oldNode.refs, 'refsselected')
        }
        setTimeout(()=>{
            if (newValue){
                const newNode = treeRef.value.getNodeByKey(newValue)
                if (newNode.hasOwnProperty('refs1') && newNode.refs1)  enableMarks(newNode.refs1, 'refs1selected')
                if (newNode.hasOwnProperty('refs2') && newNode.refs2)  enableMarks(newNode.refs2, 'refs2selected')
                if (newNode.hasOwnProperty('refs') && newNode.refs)   enableMarks(newNode.refs, 'refsselected')
            }
        }, 50)
    }
    watch(selected, (newValue, oldValue) => {
        if (newValue){
            const node = treeRef.value.getNodeByKey(newValue)
            const refs = [
                ...(node.refs1??[]),
                ...(node.refs2??[]),
                ...(node.refs??[])
            ]
            if (refs.length > 0) {
                tabSelected.value = className2file[refs[0]].name
            }
        }
        highlightSelected(newValue, oldValue)
    })
    function highlightTicked(newValue, oldValue) {
        if (oldValue){
            for (const key of oldValue) {
                const node = treeRef.value.getNodeByKey(key)
                if (node.hasOwnProperty('refs1') && node.refs1)    disableMarks(node.refs1, 'refs1enable')
                if (node.hasOwnProperty('refs2') && node.refs2)    disableMarks(node.refs2, 'refs2enable')
                if (node.hasOwnProperty('refs') && node.refs)     disableMarks(node.refs, 'refsenable')
            }
        }
        setTimeout(()=>{
            if (newValue){
                for (const key of newValue) {
                    const node = treeRef.value.getNodeByKey(key)
                    if (node.hasOwnProperty('refs1') && node.refs1)    enableMarks(node.refs1, 'refs1enable')
                    if (node.hasOwnProperty('refs2') && node.refs2)    enableMarks(node.refs2, 'refs2enable')
                    if (node.hasOwnProperty('refs') && node.refs)     enableMarks(node.refs, 'refsenable')
                }
            }
        }, 50)
    }
    watch(ticked, highlightTicked)

// ===========================================
function allChildKeys(node){
    if (node.hasOwnProperty('children') && node.children.length > 0) {
        return [node.key, ...node.children.map(allChildKeys).flat(1)]
    } else {
        return [node.key]
    }
}
function allChildKeysFiltered(node, filterFn){
    let selfkey = []
    if (filterFn(node))
        selfkey = [node.key]
    if (node.hasOwnProperty('children') && node.children.length > 0) {
        return [...selfkey, ...node.children.map(x=>allChildKeysFiltered(x, filterFn)).flat(1)]
    } else {
        return selfkey
    }
}

async function formSubmit() {
    btn_disabled.value = true
    if (selected.value){
        const node = treeRef.value.getNodeByKey(selected.value)
        console.log(selected.value)
        //printNode(node)
        if (node.hasOwnProperty('refs1') && node.refs1)    disableMarks(node.refs1, 'refs1selected')
        if (node.hasOwnProperty('refs2') && node.refs2)    disableMarks(node.refs2, 'refs2selected')
        if (node.hasOwnProperty('refs') && node.refs)     disableMarks(node.refs, 'refsselected')
    }
    const inputs = {
        Geboortedatum: {
            value: geboortedatum.value,
            source: "wallet__date_of_birth",
            reason: "nodig om te bepalen of de gebruiker een notificatie moet ontvangen",
        },
        // only need to be present when functionality == 'notificatie'
        Vandaag: {
            value: vandaag.value,
            source: "clock_on_user_device",
            reason: "nodig om te bepalen of de notificatie op dit moment relevant is",
        },
        // only need to be present when functionality == 'inkomstenbelasting_aow'
        Kalenderjaar: {
            value: kalenderjaar.value,
            source: "clock_on_user_device",
            reason: "",
        },
        AowBedrag: {
            value: aowBedrag.value,
            source: "mijnpensioenoverzicht",
            reason: "",
        },
        PotjesBedragen: {
            value: potjesBedragen.value,
            source: "mijnpensioenoverzicht",
            reason: "",
        },
        Alleenstaand: {
            value: true,
            source: "wallet",
            reason: "",
        },
    }
    const solutions = await traceableAsync(functionality.value.value.model, functionality.value.value.functionality, inputs)
    console.log(solutions)
    const solutionElement = document.getElementById("solution")
    solutionElement.data = solutions
    selected.value = null
    ticked.value = []
    nodes.value = []
    btn_disabled.value = false
    const newTraces = solutions.map(x=> herleidbare_uitleg(x.Herleidbaarheid, x))
    nodes.value = newTraces
    const newKeys = newTraces.map(allChildKeys).flat(1)

    const allRefs = newTraces.map(solu => [...utils.treeFlatMap(solu, node => [
        ...(node.refs1??[]),
        ...(node.refs2??[]),
        ...(node.refs??[]) 
    ])]).flat()
    //utils.pri({allRefs})
    const shownPages = allRefs.map(x => className2file[x]
    ).filter((obj, index, self) => 
        index === self.findIndex(o => o.name === obj.name)
    ).map(obj => {
        const label = fileObjects[obj.year][obj.filename].label
        const marked = fileObjects[obj.year][obj.filename].marked
        return {...obj, label, marked}
    })
    tabs.value = shownPages
    if (!tabSelected.value || !shownPages.map(x=>x.name).includes(tabSelected.value)) {
        tabSelected.value = shownPages[0].name
    }

    const rootKeys = newTraces.map(x => x.key)
    // root is in het begin ingeklapt om de focus meer op de gehighlighte tekst te leggen
    expanded.value = newKeys.filter(x => rootKeys.indexOf(x) === -1)
    //const factKeys = newTraces.map(y=>allChildKeysFiltered(y, x=>x.hasOwnProperty('children'))).flat(1)
    //ticked.value = factKeys
    setTicket(detailedTree.value)
    //setTimeout(()=>{
        //highlightTicked(ticked.value, [])
    //}, 1000)
}
// -------------------------------------------
function uniqueId() {
  return 'key-' + Date.now() + '-' + Math.random().toString(36).substr(2, 9);
}

function refs2quotesStr(refs) {
    return utils.refs2quotesStr(refs, className2file, fileObjects) 
}

function dateObjToString(obj){
    return `${obj.datum[2]}-${obj.datum[1]}-${obj.datum[0]}`
}
function leaf2str(obj){
    if (obj.functor == "datum")
        return dateObjToString(obj)
    if (obj.functor == "leeftijd"){
        const leeftijd = obj.leeftijd
        const ys = leeftijd[0]
        const ms = leeftijd[1]
        return `${ys} jaar en ${ms} ${ms==1 ? 'maand' : 'maanden'}`
    }
    if (obj.functor == "gehele_euros"){
        const euro = obj.gehele_euros[0]
        return `${euro} euro`
    }
}

function herleidbare_uitleg(obj, sol) {
    if (obj.functor === "node") {
        const node = obj.node
        let nodename = ""
        let refs1 = []
        let label = ""
        let preBody = ""
        let preLabel = ""
        const operator = node[1].operator[0].v
        if (node[0].functor === "fact") {
            nodename = `[fact] ( ${node[0].fact[0]} ) `
            if (node[0].fact[1].functor === "ref") {
                refs1 = node[0].fact[1].ref[0].map(x=>x.v)
                preLabel += refs2quotesStr(refs1)
            } else if (node[0].fact[1].functor === "implication") {
                //label += node[0].fact[1].implication[0] + ` ( ${operator.replaceAll('_', ' ')} )`
                label += node[0].fact[1].implication[0]
                refs1 = []
            } else if (node[0].fact[1].functor === "reason") {
                //TODO dit geeft een error omdat node[0].fact[0] blijkbaar niet altijd een string is??
                //label += `${node[0].fact[0].replaceAll('_', ' ')} ( ${node[0].fact[1].reason[0]} )`
                label += `${node[0].fact[0]} ( ${node[0].fact[1].reason[0]} )`
                nodename += ` ( ${operator} ) `
                refs1 = []
            } else if (node[0].fact[1].functor === "calculation") {
                const calcu = node[0].fact[1].calculation
                label += ["<strong>",
                          leaf2str(sol[calcu[0].expr].leaf[0]),
                          "</strong>",
                          calcu[1].txt,
                          "<strong>",
                          leaf2str(sol[calcu[2].expr].leaf[0]),
                          "</strong>"].join(" ")
                refs1 = []
            }
        } else if (node[0].functor === "base") {
            nodename = "[base operator] "
            if (node[0].base[0].ref){
                refs1 = node[0].base[0].ref[0].map(x=>x.v)
                preLabel += refs2quotesStr(refs1)
                label += operator.replaceAll('_', ' ')
            } else if (node[0].base[0].functor === "implication") {
                //label += node[0].base[0].implication[0] + ` ( ${operator.replaceAll('_', ' ')} )`
                 label += node[0].base[0].implication[0]
                refs1 = []
            } else {
                refs1 = []
            }
        } else if (node[0].functor === "app") {
            nodename = "[app]"
            //refs1 = node[0].app[0].ref[0].map(x=>x.v)
            label += node[0].app[0].ref[0].map(x=>x.v).join("; ")
        } else {
            nodename = "[not_found]"
            refs1 = []
            console.log("nodename Not FOUND")
        }
        let refs2
        if (node[1].operator[1].functor === "ref") {
            refs2 = node[1].operator[1].ref[0].map(x=>x.v)
            preBody += refs2quotesStr(refs2)
        }
        else if (node[1].operator[1].functor === "reason") {
            label += ": " + node[1].operator[1].reason[0]
            refs2 = []
        }
        const children = node[2].children[0]
        //printNode({label, preBody, preLabel, nodename, refs1, operator, refs2, children})
        return {
            key: uniqueId(),
            refs1: refs1,
            refs2: refs2,
            //label: label ?? `${[refs1, refs2]} ${operator} ( ${nodename} )`,
            //label: label + ` ( ${nodename} = ${operator} )`,
            label,
            //label: label ?? `(${nodename} = ${operator})`,
            preLabel,
            body: `${nodename}` + (operator ? `( ${operator} )` : ''),
            preBody,
            children: children.map(x=>herleidbare_uitleg(x, sol)),
            norefs: refs1.length == 0 && refs2.length == 0,
        }
    } else if (obj.functor === "leaf") {
        const leaf = obj.leaf
        let value
        const literalname = leaf[0].functor
        if (leaf[0].functor === "jaar") {
            value = leaf[0].jaar[0]
        } else if (leaf[0].functor === "datum") {
            const datum = value = leaf[0].datum
            const y = datum[0]
            const m = datum[1]
            const d = datum[2]
            value = `${d}-${m}-${y}`
        } else if (leaf[0].functor === "leeftijd") {
            const leeftijd = leaf[0].leeftijd
            const ys = leeftijd[0]
            const ms = leeftijd[1]
            value = `${ys} jaar en ${ms} ${ms==1 ? 'maand' : 'maanden'}`
        } else if (leaf[0].functor === "gehele_euros") {
            value = leaf2str(leaf[0])
        } else {
            value = "not_found"
            console.log("literal Not FOUND")
        }
        let refs = []
        let label = ""
        let preLabel = ""
        let body = ""
        if (!leaf[1].hasOwnProperty("functor")) {
            label += `tussenresultaat: ${value}`
        } else if (leaf[1].functor === "ref") {
            refs = leaf[1].ref[0].map(x=>x.v)
            preLabel += refs2quotesStr(refs)
        } else if (leaf[1].functor === "userdata") {
            refs = []
            //label += leaf[1].userdata[0] + `: <strong>[${value}]</strong> ` + leaf[1].userdata[1]
            label += leaf[1].userdata[0] + `: <strong>[${value}]</strong> `
            body += leaf[1].userdata[1]
        } else if (leaf[1].functor === "result") {
            refs = []
            //label += 'resultaat: ' + leaf[1].result[0] + ' (' + leaf[1].result[1] + ')'
            label += `resultaat: <strong>${value}</strong>`
        }
        //printNode({label, literalname, value, refs, preLabel})
        return {
            key: uniqueId(),
            refs: refs,
            //label: `${value} ( ${literalname} )`,
            //label: label + ` ( ${literalname} = ${value} )`,
            label,
            //label: label + `${literalname} | ${value}` + nodeStr(obj),
            preLabel,
            body,
            norefs: refs.length == 0,
        }
    } else {
        return {
            key: uniqueId(),
            label: nodeStr(obj),
        }
    }
}
// ===========================================
    const vueState = {
      // form variables
      functionality,
      functionality_options,
      geboortedatum,
      vandaag,
      kalenderjaar,
      aowBedrag,
      potjesBedragen,

      btn_disabled,

      treeSplitterModel,
      tabSplitterModel,
      tabs,
      tabSelected,

      formSubmit,

      neededInputs,

      // tree variables
      treeRef,
      selected,
      ticked,
      expanded,
      nodes,
      detailedTree,

      enableMarks,
      disableMarks,
    }
    window.vueState = vueState
    return vueState
  }
})
window.app = app
app.use(Quasar)
app.mount('#q-app')
</script>
</body>
</html>
